/*
 * Plot - plot time-based data on screen and to file with interactive controls
 * Copyright (C) 2006  Jonas Berlin <xkr47@outerspace.dyndns.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 ****
 * gtkutil - misc gtk functions
 */

#include "gtkutil.xh"

void x_gdk_draw_rectangle(GdkDrawable *drawable, GdkGC *gc, gboolean filled, gint x1, gint y1, gint x2, gint y2) {
   if(x1 > x2) {
      int t = x1;
      x1 = x2;
      x2 = t;
   }

   if(y1 > y2) {
      int t = y1;
      y1 = y2;
      y2 = t;
   }

   if(filled) {
      ++x2;
      ++y2;
   }

   gdk_draw_rectangle(drawable, gc, filled, x1, y1, x2-x1, y2-y1);
}

//void x_gdk_draw_arrow(GdkDrawable *drawable, GdkGC *gc, int fx, int fy, int tx, int ty, int arrow_side_len

void x_gtk_adjustment_set_value_clamped(GtkAdjustment *adj, double value) {
   value = CLAMP (value,
		  adj->lower,
		  adj->upper - adj->page_size);

   gtk_adjustment_set_value(adj, value);
}

void x_gtk_adjustment_set_range(GtkAdjustment *adj, double min, double max) {
   adj->lower = min;
   adj->upper = max;
   x_gtk_adjustment_set_value_clamped(adj, adj->value);
   gtk_adjustment_changed(adj);
}

GtkAdjustment *x_gtk_adjustment_clone(GtkAdjustment *orig) {
   GtkAdjustment *adj = GTK_ADJUSTMENT(gtk_adjustment_new(orig->value,
							  orig->lower, orig->upper,
							  orig->step_increment, orig->page_increment,
							  orig->page_size));
   g_object_ref(adj);
   gtk_object_sink(GTK_OBJECT(adj));
   return adj;
}
